(c) C. Alex McLean 2007
Released under GPL version 2.  See the COPYING file or gnu.org for details.

> module Logger where 

> import System.Posix.Process (getProcessID)
> import System.Posix.Time (epochTime)
> import System.Time 
> import System.IO

> import MyTime

> openLog :: IO (String -> IO ())
> openLog = 
>     do pid <- getProcessID
>        etime <- epochTime
>        start <- getClockTime
>        let path = "logs/" ++ (show etime) ++ "." ++ (show pid) ++ ".txt"
>        fh <- openFile path AppendMode
>        hSetBuffering fh LineBuffering
>        return (\x -> do now <- getClockTime
>                         hPutStrLn fh $ show (microDiff now start) ++ " " ++ x
>                         return ()
>               )

