(c) C. Alex McLean 2007
Released under GPL version 2.  See the COPYING file or gnu.org for details.

> module Main where

> import Control.Concurrent
> import Control.Concurrent.MVar
> import System.Console.Readline
> import System.Exit
> import System.IO
> import Logger

> import Music
> import Parse
> import Player

> main :: IO ()
> main = do initPlayer
>           logger <- openLog
>           musicM <- newMVar [[Rest]]
>           thread <- forkIO (player musicM)
>           shell logger musicM

> shell :: (String -> IO ()) -> MVar [[Event String]] -> IO ()
> shell logger musicM 
>           = do s <- readline "~> "
>                case s of 
>                       Nothing          -> return ()
>                       Just (':':'q':_) -> return ()
>                       Just s' -> do addHistory s'
>                                     setMusic musicM s'
>                                     logger s'
>                                     shell logger musicM

> setMusic :: MVar [[Event String]] -> String -> IO ()
> setMusic musicM s 
>     = case (parseMusic s) of
>       Left err -> do putStr "parse error at "
>                      print err
>       Right parsed -> do takeMVar musicM
>                          putMVar musicM $ structureToList parsed


