(c) C. Alex McLean 2007
Released under GPL version 2.  See the COPYING file or gnu.org for details.

> module MyTime where

> import System.Time
> import Control.Concurrent (threadDelay)


> cpm   = 120 * 2 -- cycles per minute
> delay = 60000000 `div` cpm


> normalTime t = (points + 1) * bar
>                where points = t `div` bar
>                      bar = (delay * 16)
               

> wait start n = do 
>   now <- getClockTime
>   let micros = (n * delay - (microDiff now start))
>   threadDelay (if micros > 0 
>                then micros
>                else 0
>               )

> microDiff :: ClockTime -> ClockTime -> Int
> microDiff a b = diffToMicro (diffClockTimes a b)

> diffToMicro td = picoToMicro (tdPicosec td) + 1000000 * (tdSec td + 60 * (tdMin td + 60 * (tdHour td + 24 * (tdDay td + 30 * (tdMonth td + 365 * tdYear td)))))

> picoToMicro :: Integer -> Int
> picoToMicro a = round ((iToF a) / 1000000)

> microToPico :: Int -> Integer
> microToPico a = (toInteger a) * 1000000

> iToF :: Integer -> Float 
> iToF a = fromInteger(a)
